print macro string
   mov   curx,0
   mov   cury,0
   mov   left_margin,0
   call  blop
   lea   dx,string
   call  print_string
   endm
; OKFILE4 is a group of file reading routines that are
; called from OKFMAIN.
;
;  LOT added 8/3/87
;  postscript added 10/29/87
;
;
INCLUDE   f:\ok\okfiles.asm
dseg    SEGMENT PUBLIC 'DATA'
    ASSUME CS:cseg,DS:dseg,ES:dseg
;
EXTRN   buffer:WORD,width_bytes:WORD,height_pix:WORD
EXTRN   lot_header:BYTE,pos_header:word
extrn   width_pix:word
extrn   curx:word,cury:word,left_margin:word
extrn   srow:word,lrow:word,scol:word,lcol:word
EXTRN   vint:word,vphase:word
extrn   sx:word,sy:word,spnt:word
extrn   ex:word,ey:word,epnt:word
;
;
;
;  LOCAL Variables
;
buf_counter  dw  0
lot_check  db 1,0,0,0,1,0,8,0,44h,0,0,0,0,0ch,7fh,9,6
orgx  dw  0
orgy  dw  0
lotx  dw  0
loty  dw  0
dpp    db  0
oper  db  6 dup(0)
cur_col db 0
; local only stuff used by the programs
savebp  dw  0
savesi  dw  0
pass    DW    0
buffcount   DW    0
in_buffer   DW    0
curr_font  db  0
curr_color db  0
xscale  dw  0
yscale  dw  0
pos_dec1  db '    '  ; decimal for pos x
pos_dec2  db '    '  ; decimal for pos y
;
;   ; hijaak header follows
; %!PS-Adobe-2.0 EPSF-1.2
; %%BoundingBox:  27 616 387 765
; %%Creator: HiJaak by Inset Systems
; %%EndComments
; gsave
; /picstr 79 string def
; { 1 exch sub } settransfer
; 27 765 moveto
; 360 149 scale
; 0 -1 rmoveto
; currentpoint translate
; 632 263 1
; [632 0 0 -263 0 263 ]
; { currentfile picstr readhexstring pop }
; image
; grestore
; showpage
;  %%ctrl-d
;
;
;
;
post_head equ this word
    db   '%!PS-Adobe-2.0 EPSF-1.2',13,10
    db   '%%BoundingBox:  27 616 387 765',13,10
    db   '%%Creator:OPTIKS Graphics Spreadsheet',13,10
    db   '%%Title:'
Pos_title db   'File created from OPTIKS    ',13,10
    db   '%%EndComments ',13,10
    db   '% This is a postscript program generated '
    db   'by OPTIKS copyright 1990 by K. Graham',13,10
    db   '% This is only a small testing program and image data.',13,10
    db   '% This data can be modified for use in other applications',13,10
    db   '% This program is adapted from the example on Page 170',13,10
    db   '% of the Postscript Language Reference Manual (Red Book).',13,10
    db   'gsave',13,10
    db   '/picstr '
; pos picl has to have a line length
pos_picl db '     string def',13,10
    db   '27 765 moveto',13,10
pos_scx db '      '
pos_scy db '      '
    db   ' scale',13,10
    db   '{ 1 exch sub } settransfer',13,10
    db   '0 -1 rmoveto',13,10
    db   'currentpoint translate',13,10
;
pos_wid   db  '      '
pos_hgt  db  '     1',13,10
    db   '['
pos_wid1 db  '     0 0   '
pos_hgt1 db  '     0   '
pos_hgt2 db  '     ]  ',13,10
    db   '  {currentfile picstr readhexstring pop}',13,10
    db   '  image',13,10
  
post_end equ $-post_head
post_ps db  'grestore',13,10
    db  'showpage',13,10
post_ps_len equ $-post_ps
;
;
;
;
;
dseg    ENDS
cseg    SEGMENT PUBLIC 'CODE'
    ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN   reset_segs:NEAR,read_file:NEAR,print_string:near
extrn   blop:near,flush_buffer:near,calc_file_size:near
extrn   next_wait:near,fill_buffer:near,write_file:near
extrn    xor_liner:near,cc_setup:near
PUBLIC   lot_in,lot_read
public   pos_in,pos_out,pos_read,pos_write
POS_read proc  near
; have a si pointer into the buffer in savesi
; and the current buffer count is in savebp
    call   reset_segs
    mov    di,0
    mov    si,savesi
    mov    bp,savebp
; ready to loop through the lines
    mov    cx,height_pix
    mov    dx,width_bytes
    mov    es,buffer
    mov    ds,buffer
pr_loop:
    push   cx
; check to see if there is enough in the output buffer
    cmp    di,2000h
    jle    good_pr_di
    call   ps_flush
    jc   done_pr
good_pr_di:
    mov    cx,dx
    call   ps_line   ; gets a ps line
    jc   done_pr
    pop    cx
    loop   pr_loop
    push   cx
done_pr:
    pop   cx
    cmp   di,0
    je    all_done_pr
    call  ps_flush
all_done_pr:
    call   reset_segs
    stc
    ret
ps_line:
; gets one line of ps data from buffer
    push   cx
    mov    bx,0
    call   get_hex
    jc   done_ps_line
    mov    bl,al
; now get another hex digit
    push   bx
    call   get_hex
    pop    bx
    jc   done_ps_line
    mov    cl,4
    shl    bl,cl
    or   al,bl
    stosb
    pop    cx
    loop   ps_line
    clc
    ret
done_ps_line:
    pop   cx
    stc
    ret
;
;
get_hex:
    call   get_ps_byte
    jnc    ok_ps_get
    stc
    ret
ok_ps_get:
    cmp    al,'%'
    jne    no_comm
    call   pos_eol
    jnc    get_hex
    stc
    ret
no_comm:
    mov    ah,0
    cmp    ax,'0'
    jl   get_hex
    cmp    ax,'9'
    jle    ps_got_low
    cmp    ax,'A'
    jl   get_hex
    cmp    ax,'F'
    jle    ps_got_low2
    cmp    ax,'a'
    jl   get_hex
    cmp    ax,'f'
    jg   get_hex
ps_got_low1:
    sub    ax,32
ps_got_low2:
    sub    ax,7
ps_got_low:
    and    al,0fh
    clc
    ret
;
ps_new_buff:
; get a new buffer
    push   ax
    push   bx
    push   cx
    push   dx
    push   di
    push   bp
    mov    dx,4000h
    mov    cx,3800h
    call   read_file
    cmp    ax,0
    jg   got_new_buff
bad_new_in:
    pop   bp
    pop   di
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    stc
    ret
got_new_buff:
    mov    si,4000h
    add    ax,4000h
    pop    bp
    mov    bp,ax
    pop   di
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    ret
ps_flush:
; flushes the current ps buffer
    push   ds
    push   es
    push   si
    push   cx
    push   dx
    push   bp
    mov    dx,0
    mov    cx,di
    mov    di,0
    push   di
    call   reset_segs
    call   flush_buffer
    call   next_wait
    pop    di
    pop    bp
    pop    dx
    pop    cx
    pop    si
    pop    es
    pop    ds
    ret
POS_read endp
POS_IN  proc  near
    call   reset_segs
    cmp  pos_header[2],'!%'
    jne  bad_pos_in
; reading post script files is a search for the matrix containing
; the data nad then the hex data after the image statement
;
; prime the pump and get a bufferlead of data
;
    mov    dx,4000h
    mov    cx,3000h
    push   ds
    mov    ds,buffer
    call   read_file
    pop    ds
    cmp    ax,0
    jg   got_pos_buffer
bad_pos_in:
    stc
    ret
got_pos_buffer:
; through the lines for the array for the picture
; the dimensions should be right after scale
    add    ax,4000h
    mov    bp,ax
    mov    savebp,ax
    mov    cx,50   ; this has to be in first 50 lines or we give up
    mov    si,4000h ; start of string
    push   ds
    mov    ds,buffer
    call   pos_eol   ; go to beginning of next line
    cld
pos_head_loop:
    push   cx
    lodsb
    cmp    al,'%'
    je   pos_next_line
    cmp    al,13
    jne    check_for_scale
    lodsb
    jmp    pos_done_line
check_for_scale:
; here we have a non eol, non comment thing, It must be significant
    cmp    al,'S'
    je   got_s
    cmp    al,'s'
    je   got_s
pos_jmp_back:
    pop    cx
    jmp    pos_head_loop
got_s:
    lodsb
    cmp    al,'c'
    jne    pos_jmp_back
    lodsb
    cmp    al,'a'
    jne    pos_jmp_back
    lodsb
    cmp    al,'l'
    jne    pos_jmp_back
    lodsb
    cmp    al,'e'
    jne    pos_jmp_back
    pop    cx
    jmp    found_scale
pos_next_line:
    call   pos_eol   ; go to beginning of next line
pos_done_line:
    pop    cx
    loop   pos_head_loop
    pop    ds
    stc
    ret
pos_eol:
; this runs out the line until a 13,10 is found
    call   get_ps_byte
    jc   bad_get_ps_byte
    cmp    al,13
    jne    pos_eol
    call   get_ps_byte
    ret
bad_get_ps_byte:
    stc
    ret
get_ps_byte:
    cmp   si,bp
    jl    ok_next_byte
    call  ps_new_buff
    jnc   get_ps_byte
    stc
    ret
ok_next_byte:
    lodsb
    clc
    ret
found_scale:
; here we have found the word scale (in lower case)
; we have to search through for a number
    mov   cx,100  ; look through 100 characters only
    lea   di,pos_dec1
    mov   word ptr pos_dec1,'  '
    mov   word ptr pos_dec1[2],'  '
; strategy is to search for numerics and put at least 4 of them in oven
fsxcale_loop:
    lodsb
    cmp   al,'%'
    jne   fsx_no_comment
    call  pos_eol
    jmp   fsxcale_loop
fsx_no_comment:
    cmp   al,'0'
    jl    fsx_end_loop
    cmp   al,'9'
    jg    fsx_end_loop
; found the x scale
    jmp   found_x_scale
fsx_end_loop:
    loop  fsxcale_loop
    pop   ds
    stc
    ret
found_x_scale:
    stosb
    lodsb
    cmp   al,'0'
    jl   got_x
    cmp  al,'9'
    jg   got_x
    jmp  found_x_scale
got_x:
    cmp  al,'%'
    jne  by_posx_eol
    call pos_eol
by_posx_eol:
; have the x scale, now the y
    mov   cx,100  ; look through 100 characters only
    lea   di,pos_dec2
    mov   word ptr pos_dec2,'  '
    mov   word ptr pos_dec2[2],'  '
; strategy is to search for numerics and put at least 4 of them in oven
fsycale_loop:
    lodsb
    cmp   al,'%'
    jne   fsy_no_comment
    call  pos_eol
    jmp   fsycale_loop
fsy_no_comment:
    cmp   al,'0'
    jl    fsy_end_loop
    cmp   al,'9'
    jg    fsy_end_loop
; found the y scale
    jmp   found_y_scale
fsy_end_loop:
    loop  fsycale_loop
    pop   ds
    stc
    ret
found_y_scale:
    stosb
    lodsb
    cmp   al,'0'
    jl   got_y
    cmp  al,'9'
    jg   got_y
    jmp  found_y_scale
got_y:
    cmp  al,'%'
    jne  by_posy_eol
    call pos_eol
by_posy_eol:
; now we have to loop through for the image stuff
   mov   cx,10  ; image should be withing ten lines of scale
pos_i_loop:
    lodsb
pos_i_loop2:
    cmp   al,'%'
    je    pos_i_eol_loop
    cmp   al,13
    je    pos_i_eloop
    cmp   al,'I'
    je    got_i
    cmp   al,'i'
    je    got_i
    jmp   pos_i_loop
got_i:
    lodsb
    cmp   al,'m'
    jne    pos_i_loop2
    lodsb
    cmp   al,'a'
    jne    pos_i_loop2
    lodsb
    cmp   al,'g'
    jne    pos_i_loop2
    lodsb
    cmp   al,'e'
    jne    pos_i_loop2
    jmp   got_image
pos_i_eol_loop:
    call  pos_eol
pos_i_eloop:
    loop  pos_i_loop
    pop  ds
    stc
    ret
got_image:
    call   pos_eol   ; go to beginning of next line
    pop  ds
    call reset_segs
; got the image
    mov   savesi,si
; fix the x and the y
    mov   bx,0
    lea   si,pos_dec1
    lodsb
    and   al,0fh
    mov   bl,al
    lodsb
    cmp   al,' '
    je    done_dec1
    and   al,0fh
    mov   cx,4
    shl   bl,cl
    or    bl,al
    lodsb
    cmp   al,' '
    je    done_dec1
    and   al,0fh
    shl   bx,cl
    or    bl,al
    lodsb
    cmp   al,' '
    je    done_dec1
    and   al,0fh
    shl   bx,cl
    or    bl,al
done_dec1:
    call  pack2dec
    add   bx,7
    mov   cl,3
    shr   bx,cl
    mov   width_bytes,bx
; now the dec2 or y value
    mov   bx,0
    lea   si,pos_dec2
    lodsb
    and   al,0fh
    mov   bl,al
    lodsb
    cmp   al,' '
    je    done_dec2
    and   al,0fh
    mov   cx,4
    shl   bl,cl
    or    bl,al
    lodsb
    cmp   al,' '
    je    done_dec2
    and   al,0fh
    shl   bx,cl
    or    bl,al
    lodsb
    cmp   al,' '
    je    done_dec2
    and   al,0fh
    shl   bx,cl
    or    bl,al
done_dec2:
    call  pack2dec
    mov   height_pix,bx
    clc
    ret
pack2dec:
; there is a packed decimal number in bx
    mov   ax,bx
    and   bx,000fh
    mov   cl,4
    shr   ax,cl
    push  ax
    and   ax,000fh
    mov   cl,10
    mul   cl
    add   bx,ax
    pop   ax
    mov   cl,4
    shr   ax,cl
    push  ax
    and   ax,000fh
    mov   cl,100
    mul   cl
    add   bx,ax
    pop   ax
    mov   cl,4
    shr   ax,cl
    mov   cx,1000
    mul   cx
    add   bx,ax
    ret
POS_in  endp
hexstr:
; writes out the 4 digit, suppressing leading zeroes
    cld
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    xchg  ax,dx
    div   cl
    or    ax,3030h
    xchg  ax,dx
    cmp   al,30h
    jne   hs8
    mov   al,20h
    cmp   ah,30h
    jne   hs8
    mov   ah,20h
    cmp   dl,30h
    jne   hs8
    mov   dl,20h
hs8:
    stosw
    xchg  ax,dx
    stosw
    ret
;
;
;
; ax dx has the decimal for doing the x stuff
POS_out proc  near
    call  reset_segs
    call  calc_file_size
; this does the postscript out
    mov   ax,width_bytes
    shl   ax,1
    shl   ax,1
    shl   ax,1
    lea   di,pos_wid
    call  hexstr
; ax has the horizontal width in bits
    lea   di,pos_scx
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
    lea   di,pos_wid1
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
; now do the same for the height
    mov   ax,height_pix
; ax has the vertical height in bits
    lea   di,pos_hgt1
    call  hexstr
;
    lea   di,pos_hgt
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
;
    lea   di,pos_hgt1
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
;
    lea   di,pos_hgt2
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
;
    lea   di,pos_scy
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
;
    lea   di,pos_picl
    xchg  ax,dx
    stosw
    xchg  ax,dx
    stosw
    lea   di,pos_hgt1
    cld
    mov   cx,3
    mov   al,20h
repz    scasb
    dec   di
    dec   di
    mov   al,'-'
    stosb
; have set the postscript parms, now must write it out to file
    lea   dx,post_head
    mov   cx,post_end
    call  write_file
    clc
    ret
POS_out endp
POS_write proc  near
; the strategy here is to set up a buffer and print it out as hex
; get a buffer full of stuff and then go through the thing looping
; for each line, calling HEX_OUT

   call  reset_segs
; get a buffer full of data
   call  fill_buffer
   jnc   good_wread
   stc
   ret
good_wread:
   call  reset_segs
; ax and cx return with the amount of data in the buffer
   mov   bp,ax
   mov   dx,width_bytes
   mov   cx,height_pix
   mov   si,0
   mov   di,4000h
   cld
wpos_loop:
   push  cx
   push  dx
   push  bp
   mov   cx,dx
   push  ds
   push  es
   mov   es,buffer
   mov   ds,buffer
   call  hex_out
   pop   es
   pop   ds
   pop   bp
   pop   dx
   push  dx
   sub   bp,dx
   cmp   bp,0
   jg    good_bp
   call  fill_pos
   jc    bad_pos_fill
good_bp:
   cmp   di,6000h
   jl    good_si
   call  write_pos
   jc   bad_pos_fill
good_si:
   pop   dx
   pop   cx
   loop  wpos_loop
   call  reset_segs
   call  write_pos
    lea   dx,post_ps
    mov   cx,post_ps_len
    call  write_file
   stc
   ret
bad_pos_fill:
   pop  dx
   pop  cx
   call  reset_segs
   call  write_pos
    lea   dx,post_ps
    mov   cx,post_ps_len
    call  write_file
   stc
   ret
fill_pos:
; get some more lines for the loop
   push  dx
   push  di
   push  ds
   push  es
   call  reset_segs
   call  fill_buffer
   pop   es
   pop   ds
   pop   di
   pop   dx
   mov   si,0
   cmp   ax,0
   je    fill_bad
   mov   bp,ax
   clc
   ret
fill_bad:
   stc
   ret
write_pos:
; get that postscript buffer out
   cmp   di,4000h
   jg    ok_di
   stc
   ret
ok_di:
   push  ds
   push  es
   push  dx
   push  bp
   mov   dx,4000h
   mov   cx,di
   sub   cx,dx
   mov   di,4000h
   push  si
   push  di
   call  next_wait
   mov   ds,buffer
   call  write_file
   pop    di
   pop    si
   pop    bp
   pop    dx
   pop    es
   pop    ds
   ret
POS_write endp
;
;
hex_out proc  near
; converts cx characters to hexidemal bytes
; adds spaces every 8 and crlf every 64
   push  ax
   push  bx
   push  cx
   push  dx
   push  bp
; set up counters, bl has the 8 count, bh has the 64 count
   mov   bx,0
ho_loop:
   push  cx
   cld
   lodsb
   xor   al,0ffh
   mov   cl,16
   mov   ah,0
   div  cl
; low nibble in ah, high in al
   or   ax,3030h
   cmp  al,3ah
   jl   ok_al
   add  al,7
ok_al:
   cmp  ah,3ah
   jl   ok_ah
   add  ah,7
ok_ah:
   stosw
   mov al,20h
   stosb
   inc   bl
   cmp   bl,8
   jl    no_spaces
   mov   al,20h
   stosb
   mov   bl,0
   inc   bh
   cmp   bh,8
   jl    no_spaces
   mov   bh,0
   mov   ax,0a0dh
   stosw
no_spaces:
   pop   cx
   loop  ho_loop
   mov   ax,0a0dh
   stosw
   pop   bp
   pop   dx
   pop   cx
   pop   bx
   pop   ax
   ret
hex_out endp
;
;
;
draw_line proc  near
; this tdraws a line in lotx,lty from the two points in oper
;
   mov  ax,lotx
   mov  cx,xscale
   mul  cx
   mov  cx,3200
   div  cx
   mov  dx,ax
   and  dx,7
   mov  spnt,dx
   mov  cx,3
   shr  ax,cl
   add  ax,scol
   mov  sx,ax
   mov  ax,loty
   mov  cx,yscale
   mul  cx
   mov  cx,2311
   div  cx
   sub  ax,srow
   sub  ax,yscale  ; in case its screwy
   neg  ax
   mov  sy,ax
; now the end point
   call  make_curr
   mov  ax,lotx
   mov  cx,xscale
   mul  cx
   mov  cx,3200
   div  cx
   mov  dx,ax
   and  dx,7
   mov  epnt,dx
   mov  cx,3
   shr  ax,cl
   add  ax,scol
   mov  ex,ax
   mov  ax,loty
   mov  cx,yscale
   mul  cx
   mov  cx,2311
   div  cx
   sub  ax,srow
   sub  ax,yscale
   neg  ax
   mov  ey,ax
   call xor_liner
   call reset_segs
   clc
   ret
make_curr:
; takes oper and makes current
   mov  ax,word ptr oper
   xchg al,ah
   mov  lotx,ax
   mov  ax,word ptr oper+2
   xchg al,ah
   mov  loty,ax
   ret
draw_line endp
LOT_IN   PROC    NEAR
   call reset_segs
; check to see if we are in PC paint
   lea   si,lot_header.lot_sig
   lea   di,lot_check
   mov   cx,17
   cld
rep   cmpsb
   je    good_lot_head
   stc
   ret
good_lot_head:
; now calculate scale factors. A range must have been set
; complete with scol and lcol type of stuff
; this will have to be used to calculate the scalling factors
;
   call  reset_segs
   call  cc_setup
; we are assured that scol is less than lcol here
; x in lotus is 3200, y is 2311 so all of units expressed have
; to be scaled into the workspace
; for now, we will assume x = 1024
; y = 768
;   we go by x scale as the width
   mov   ax,lrow
   sub   ax,srow
   mov   yscale,ax
   mov   ax,lcol
   sub   ax,scol
   mov   cl,3
   shl   ax,cl
   mov   xscale,ax
; yscale cannot be bigger than  xscale
   cmp   yscale,ax
   jle   ok_yscale
   mov   yscale,ax
ok_yscale:
   clc
   ret
LOT_IN   ENDP
LOT_READ   PROC    NEAR
   call    reset_segs
LOT_READ   ENDP
; for now, we will assume x = 1024
; y = 768
; this will map us onto a double wide and high screen which
; can easily be shrunk
   mov   orgx,0
   mov   orgy,768   ; origin is lower left hand corner
   mov   lotx,0
   mov   loty,768   ; current pointer position
toploop:
   lea   dx,oper
   mov   cx,1
   call  read_file  ; get an operand
   jc    exit_lot
; have an operand in oper
   mov   ah,0
   mov   al,oper
   cmp   al,30h
   je    check_0
   cmp   al,0a0h
   jl    exit_lot
   cmp   al,0d0h
   jg    exit_lot
   cmp   al,0c0h
   jl    next_oper
   jg    next_oper
exit_lot:
    stc
    ret
next_oper:
    and   al,0f0h
    cmp   al,0a0h
    je    check_a
    cmp   al,0b0h
    je    check_b
; check d
    mov   al,oper
    cmp   al,0d0h
    jne   exit_lot
    jmp   fillo
check_a:
    mov   al,oper
    cmp   al,0a0h
    jne   no_move
    jmp   move
no_move:
    cmp   al,0a2h
    jne   no_draw
    jmp   draw
no_draw:
    cmp   al,0a7h
    jne   no_font
    jmp   font
no_font:
    cmp   al,0a8h
    jne   no_text
    jmp   text
no_text:
    cmp   al,0ach
    jne   no_size
    jmp   sizer
no_size:
    jmp   exit_lot
;
check_b:
    jmp   color
check_0:
    call  fillv
    jc    exit_lot
    jmp   toploop
;
;
;
fill:
   jmp  fillv
draw:
    lea  dx,oper
    mov  cx,4
    call read_file
    jnc  good_rund
    jmp   exit_lot
good_rund:
; here we have to draw a line from here to there
;
    call  draw_line
    jmp   toploop
move:
    lea  dx,oper
    mov  cx,4
    call read_file
    jnc  good_runm
    jmp   exit_lot
good_runm:
   call  make_curr
    jmp   toploop
font:
    lea  dx,oper
    mov  cx,1
    call read_file
    jnc  good_runf
    jmp   exit_lot
good_runf:
    mov  al,oper
    mov  curr_font,al
    jmp   toploop
text:
; run out text here
    lea  dx,oper
    mov  cx,1
    call read_file
    jnc  good_runt
    jmp   exit_lot
good_runt:
    mov  cl,oper
    mov  dpp,cl
runloopt:
    lea  dx,oper
    mov  cx,1
    call read_file
    jnc  good_runt1
    jmp   exit_lot
good_runt1:
; here we have to print a character
;
    cmp   oper,0
    jne   do_print
    jmp   toploop
do_print:
    mov   al,oper
;   call  print_char
    jmp  runloopt
sizer:
    lea  dx,oper
    mov  cx,4
    call read_file
    jnc  good_runs
    jmp   exit_lot
good_runs:
; control size here, later
    jmp   toploop
color:
    and   al,0fh
    mov   curr_color,al
    jmp   toploop
fillo:
   jmp  fillv
;
;
fillv:
    lea  dx,oper
    mov  cx,1
    call read_file
    jnc  good_run
    ret
good_run:
    mov  cl,oper
    mov  ch,0
    cmp  cx,0
    jg   runloop
    stc
    ret
runloop:
   push  cx
    lea  dx,oper
    mov  cx,4
    call read_file
    jnc  good_runl
    pop  cx
    stc
    ret
good_runl:
; here we have to draw a line from here to there
;
    call  draw_line
    pop  cx
    loop  runloop
    clc
    ret

cseg    ENDS
    END
