; OKMAIN.ASM - this is a procedure that calls the tree. As such it
; continues OKSTART. It sets up the quit locations and makes the
; return to exit_prog
; The public modules are:
;  Quit - reenter tree from top
;  main - first entry of tree
;
DSEG    segment public 'DATA'
extrn   quitter:word,breaker:word,tree0000:word,debug:byte
extrn   goback1:word,goback2:word,vbuffer:word,vid_wid:word
DSEG    ends
CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn reset_segs:near,do_display:near,do_tree:near
extrn end_prog:near,present:near
quit  proc  near
; resets all good stuff
       call reset_segs
       mov  sp,quitter
       ret
quit  endp
main   proc   near
public main,quit
; main entry - set up breaker and quitter
        call  reset_segs
        lea     ax,cs:main
        push    ax
        mov     breaker,sp
        jmp     enter_main
public got_slash
got_slash:
; got a slash - time to enter tree
       call  reset_segs
        mov     sp,quitter
        pop     ax
enter_main:
        lea     ax,cs:cur_loop_0
        push    ax
        mov     quitter,sp
       mov  goback2,sp
       push  ax
       push  ax
       mov  goback1,sp
        lea     si,tree0000
        mov     bp,0
        cmp     debug,2
        jne     no_bug
        int 3   ; debug break
no_bug:

        call    do_tree
        call    reset_segs
;       jmp     cur_loop
cur_loop_0:
; this allows you to directly enter the screen
        mov     sp,quitter
        pop     ax
        lea     ax,cur_loop_0
        push    ax
        mov     quitter,sp
       mov  goback2,sp
       push  ax
       push  ax
       mov  goback1,sp
cur_loop:
; now jump to routine to move around display
        call    present
        jmp     do_display
main    endp
CSEG    ENDS
        END
