; OKSELEC.ASM is a file selection program which connects
; read and write file types from a list and then branches to
; the equivalent file selection menu.

private = 0

; private is the switch to say if it is the special one
; private = 0 means that it writes all files
;
;
DSEG segment public 'DATA'
extrn     file_name:byte,mode:byte,cdisk:byte
extrn     left_margin:word,buffer:word,str_len:word
extrn     fdate:word,fsize:word,cdir:byte,cwidth:word
EXTRN     handle:WORD,strg:BYTE,curx:word,cury:word
extrn    file_off:word,wr_switch:word,font_in:word
extrn    info_sw:byte,read_end:byte
tbox  db '                                      ',10
      db 'Select a File Format and Press Enter ',10
      db '        Press Esc to exit',0
rmess db '   READ A FILE      ',0
mmess db '  MERGE A FILE      ',0
imess db 'GET FILE INFORMATION',0
smess db '   SAVE A FILE      ',0
fbox  db 14 dup(57 dup(0))
public fbox
fcount dw 0   ; cound of files on list
lline dw  60 dup(0)
lread  dw 0
lsave  dw 0
lmerge dw 0
linfo  dw 0
c_col dw 0
c_row dw 0
o_col dw 0
o_row dw 0
mousex db 0
space12  dw  6 dup(20h)
include f:\ok\okrfiles.asm
gline   db 1,1ch,47h,48h,49h,4bh,4dh,4fh,50h,51h
cfile  dw 0
;
;
DSEG ends
;
CSEG segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg

extrn  gstring:near,highlight:near
extrn present:near
extrn getkey:near,printline:near,reset_segs:near,print_string:near
extrn goback:near,exit_prog:near,prbox:near,get_file:near
extrn get_fonts:near,merge_file:near
extrn check_font:near,flush_mouse:near
;
bas_extrn macro cnt,g
extrn g&bas&cnt:near
    dw  g&bas&cnt
    endm
bas_g macro x
bas_extrn x,get_
    endm
bas_s macro x
bas_extrn x,save_
    endm
bas_m macro x
bas_extrn x,merge_
    endm
basic_read equ this word   ; line of data
bas_g 1
bas_g 2
bas_g 3
bas_g 4
bas_g 5
bas_g 6
bas_g 7
bas_g 8
bas_g 9
extrn get_pcp:near
    dw  get_pcp
basic_save equ this word   ; line of data
bas_s 1
bas_s 2
bas_s 3
bas_s 4
bas_s 5
bas_s 6
bas_s 7
bas_s 8
bas_s 9
extrn save_pcp:near
    dw  save_pcp
basic_merge equ this word   ; line of data
bas_m 1
bas_m 2
bas_m 3
bas_m 4
bas_m 5
bas_m 6
bas_m 7
bas_m 8
bas_m 9
extrn merge_pcp:near
    dw  merge_pcp
;
;
iselect:
   public iselect
    call reset_segs
    call check_font
    mov info_sw,1
    lea  si,imess
    lea  di,tbox+10
    call ms0
    mov  bp,01   ; 0=get+merge 1=info, 2=save
    jmp  by_info
rselect:
public rselect
; this routine will select a file for READING
    call reset_segs
    call check_font
    mov  info_sw,0
    lea  si,rmess
    lea  di,tbox+10
; this fills the message box
    call ms0
; fill the file box with r/w or r/o stuff, that is 0's and 1's
    mov  bp,0    ; 0=get+merge 1=info, 2=save
by_info:
    mov  read_end,0
    call fillb
    mov   ax,lread
    mov   cfile,ax
    call get_a_file   ; scroll through until enter or esc
    cmp  al,27
    jne  rs1
    call  present
    ret
rs1:
;
    mov   bx,cfile
    mov   lread,bx
    shl   bx,1
    mov   si,word ptr lline[bx]
    mov   bl,byte ptr ds:[si]
    mov   bh,0
    cmp   byte ptr ds:[si]+1,5
    je    its_basicr
    cmp   byte ptr ds:[si]+1,23
    je    gr_2
    jmp   gr_1
its_basicr:
    sub   bx,10
    shl   bx,1
    jmp   cs:basic_read[bx]
gr_2:
    mov   al,byte ptr ds:[si]+1     ; 23 from file
    mov   ah,0
    mov    cx,17
    mul    cx
    mov    file_off,ax
    mov    wr_switch,0
    sub    bx,21        ; bx has the font number from first byte
    mov    font_in,bx
    jmp    get_fonts
gr_1:
    mov   al,byte ptr ds:[si]+1
    mov   ah,0
    mov   cx,17
    mul   cx
    mov    file_off,ax
    mov    wr_switch,0
    jmp    get_file
;
;
;
;
mselect:
public mselect
; this routine will select a file for MERGING
    call reset_segs
    call check_font
    mov  info_sw,0
    mov  read_end,0
    lea  si,mmess
    lea  di,tbox+10
; this fills the message box
    call ms0
; fill the file box with r/w or r/o stuff, that is 0's and 1's
    mov  bp,0    ; 0=get+merge 1=info, 2=save
    call fillb
    mov   ax,lmerge
    mov   cfile,ax
    call get_a_file   ; scroll through until enter or esc
    cmp  al,27
    jne  mf1
    call  present
    ret
mf1:
;
    mov   bx,cfile
    mov   lmerge,bx
    shl   bx,1
    mov   si,word ptr lline[bx]
    mov   bl,byte ptr ds:[si]
    mov   bh,0
    cmp   byte ptr ds:[si]+1,5
    je    its_basicm
    cmp   byte ptr ds:[si]+1,23
    je    gm_2
    jmp   gm_1
its_basicm:
    sub   bx,10
    shl   bx,1
    jmp   cs:basic_merge[bx]
gm_2:
    mov   al,byte ptr ds:[si]+1     ; 23 from file
    mov   ah,0
    mov    cx,17
    mul    cx
    mov    file_off,ax
    mov    wr_switch,0
    sub    bx,21        ; bx has the font number from first byte
    mov    font_in,bx
    jmp    get_fonts
gm_1:
    mov   al,byte ptr ds:[si]+1
    mov   ah,0
    mov   cx,17
    mul   cx
    mov    file_off,ax
    mov    wr_switch,0
    jmp    merge_file
;
;
;
;
;
sselect:
public sselect
; this routine will select a file for SAVEING
    call reset_segs
    call check_font
    mov  info_sw,0
    mov  read_end,10
    lea  si,smess
    lea  di,tbox+10
; this fills the message box
    call ms0
; fill the file box with r/w or r/o stuff, that is 0's and 1's
    mov  bp,2    ; 0=get+merge 1=info, 2=save
    call fillb
    mov   ax,lsave
    mov   cfile,ax
    call get_a_file   ; scroll through until enter or esc
    cmp  al,27
    jne  sf1
    call  present
    ret
sf1:
;
    mov   bx,cfile
    mov   lsave,bx
    shl   bx,1
    mov   si,word ptr lline[bx]
    mov   bl,byte ptr ds:[si]
    mov   bh,0
    cmp   byte ptr ds:[si]+1,5
    je    its_basics
    jmp   gs_1
its_basics:
    sub   bx,10
    shl   bx,1
    jmp   cs:basic_SAVE[bx]
gs_1:
    mov   al,byte ptr ds:[si]+1
    mov   ah,0
    mov   cx,17
    mul   cx
    mov    file_off,ax
    mov    wr_switch,1
    jmp    merge_file    ; merge does range
;
;
;
get_a_file:
; files are now on screen, we have to have a loop to highlight
; the files
;
; dx has the current guy in it
    mov    ax,cfile
    mov    dx,0
    mov    cx,14
    div    cx
    mov    c_col,ax  ; current column
    mov    c_row,dx  ; current row
    mov    o_col,ax  ; old column
    mov    o_row,dx  ; old row
;
    call   top_line
    mov    bp,0
sel_loop:
    call   high_guy
    call   flush_mouse
gk1:
    call getkey
    cmp   dx,300h
    je    gk1
    cmp    al,27
    je     leave_selx
    cmp    al,13
    je     leave_selx
    xchg   al,ah
    lea    di,gline
    mov    cx,10
    cld
repne  scasb
    je     gk9
; a letter was pressed
    xchg   al,ah
    cmp    al,'z'
    jg     gk9
    cmp    al,'Z'
    jle    gk2
    sub    al,32
gk2:
    cmp    al,'A'
    jl     gk9
    cmp    al,'Z'
    jg     gk9
    mov   mousex,0
; have an A to Z letter
    mov    dl,al
    mov    ax,cfile
    mov    bp,ax
    mov    dh,0   ; count of how many times we searched
; search for a match
gk3:
   inc    ax
   cmp    ax,bp
   je     gk1
   cmp    ax,fcount
   jl     gk4
   mov    ax,0
   inc    dh
   cmp    dh,2
   jg     gk10
gk4:
   mov    bx,ax
   shl    bx,1
   mov    si,word ptr lline[bx]
   cmp    dl,byte ptr ds:[si]+2
   jne    gk3
if private
    cmp   byte ptr ds:[di]+13,'*'
    jne   gk3
endif
; got it
   mov    cfile,ax
   mov    cx,14
   mov    dx,0
   div    cx
   mov    c_col,ax
   mov    c_row,dx
   call   check_c
   jmp    gk10
leave_selx: jmp leave_sel
gk9:
; check for mouse activity
    cmp   bp,'KG'  ; mouse active
    jne   gk9a
    cmp   dx,400h
    jne   gk90
    inc   mousex
    cmp   mousex,20
    jge   gk9a
gk90:
   jmp    gk1
gk9a:
    mov   mousex,0
; mov cursor keys here
    dec    di
    sub    di,offset gline
    shl    di,1
    push   bp
    call   word ptr cs:gtab[di]
    pop    bp
gk10:
    push   bp
    call   un_high_guy
    pop    bp
    jmp    sel_loop
leave_sel:
    ret
key_esc:
    call present
    ret
key_ret:
   ret
key_home:
   mov   c_col,0
   mov   c_row,0
   jmp   check_c
key_up:
   dec  c_row
   jmp   check_c
key_pup:
   mov   c_row,0
   jmp   check_c
key_left:
   dec   c_col
   jmp   check_c
key_right:
   inc   c_col
   jmp   check_c
key_end:
   mov   c_col,3
   mov   c_row,13
   jmp   check_c
key_dn:
   inc  c_row
   jmp   check_c
key_pdn:
   mov   c_row,13
;  jmp   check_c
check_c:
   cmp   c_row,0
   jge   dx_nl
   mov   c_row,13
   dec   c_col
dx_nl:
   cmp   c_row,13
   jle   dx_nh
   mov   c_row,0
   inc   c_col
dx_nh:
   cmp  c_col,3
   jle  dx_hok
   mov  c_col,0
dx_hok:
   cmp  c_col,0
   jge  dx_lok
   mov  c_col,3
dx_lok:
; now calculate cfile and see if its ok
   mov  ax,c_col
   mov  cx,14
   mul  cx
   add  ax,c_row
   mov  cfile,ax
; see if we overran
   cmp  fcount,ax
   jg   ok_fcount
   dec  c_row
   jmp  check_c
top_line:
   mov   ax,cfile
ok_fcount:
; now locate and print the line.
; ax still has cfile in it
    shl  ax,1
    mov  bx,ax
    mov  si,word ptr lline[bx]
    add  si,14   ; get by 2 bytes and the bar line
; this prints the description line
;
; have to calculate line 5
    mov   ax,5
    mul   cwidth
    mov  cury,ax
    mov  curx,48
    mov  cx,74
    call  printline
    ret
gtab  dw   key_esc,key_ret,key_home,key_up,key_pup,key_left
      dw   key_right,key_end,key_dn,key_pdn
un_high_guy:
    mov   ax,c_row
    push  ax
    mov   ax,c_col
    push  ax
    mov   ax,o_col
    mov   c_col,ax
    mov   ax,o_row
    mov   c_row,ax
    call  high_guy
    pop   ax
    mov   c_col,ax
    pop   ax
    mov   c_row,ax
    ret
high_guy:
; highlight the current selection
; this has cx for length to highlight
; curx and cury have the current location
     mov   ax,6
     mul   cwidth
     mov   cury,ax
     mov   ax,c_row
     mov   o_row,ax
     inc   ax
     mul   cwidth
     add   cury,ax
     mov   ax,c_col
     mov   o_col,ax
     mov   cx,112
     mul   cx
     add   ax,64
     mov   curx,ax
     mov   cx,13
     call  highlight
     ret
;
fillb:
; files up fbox and fline
    mov  fcount,0     ; how many
    lea  di,lline     ; where they are
    lea  si,fline     ; where we find them
    cld
    mov  cx,66
fb0:
    push   cx
    lodsw
    mov   bx,ax
    cmp   byte ptr ds:[bx],4
    je    fb9
    cmp   bp,1   ; merge get and info
    jle   fb5
;
; this is a save
;
    cmp   byte ptr ds:[bx],1  ; read/only
    je    fb9
if private
    cmp   byte ptr ds:[bx]+13,'*'
    jne   fb9
endif
    cmp   byte ptr ds:[bx],20
    jle   fb8
    jmp  fb9
fb5:  ; we are in a get or a merge
;
; this is a get merge or info
;
    cmp   byte ptr ds:[bx],1  ; read/write or r/o
    jle  fb8
    cmp   byte ptr ds:[bx],10 ; basics or fonts
    jl   fb9
;   jmp  fb8
fb8:
    stosw
    inc  fcount
fb9:
    pop   cx
    loop  fb0
    mov   ax,0
    stosw
    stosw  ; a few stoppers
; move spaces to the box
    lea   di,fbox
    mov   cx,14  ; lines
space_loop:
    push   cx
    mov    cx,56
    mov    al,20h
rep  stosb
    mov    al,10
    stosb
    pop   cx
    loop  space_loop
    dec   di
    mov   al,0
    stosb
; have the table set up so now move things from the table
; into the box
    lea   si,lline
    lea   di,fbox+1
    mov   cx,4
mb0:
    push   cx
    push   di
    mov    cx,14
mb1:
    push   cx
    push   di
;
    lodsw
    cmp    ax,0
    jne    mb2
    dec    si
    dec    si
    push   si
    lea    si,space12
    jmp    mb4
mb2:
    push   si
    mov    si,ax
    inc    si
    inc    si
    mov    cx,12
rep  movsb
mb4:
    pop    si
    pop    di
    add    di,57
    pop    cx
    loop   mb1
mb9:
    pop    di
    pop    cx
    add    di,14
    loop   mb0
; now we have to print the thing
    mov   ax,6
    mul   cwidth
    mov   cury,ax
    lea   dx,fbox
    mov   left_margin,48
    mov   curx,48
    call  prbox
    ret
ms0:
    lodsb
    cmp   al,0
    je    ms1
    stosb
    jmp   ms0
ms1:
    call present
    lea   dx,tbox
    mov   left_margin,112
    mov   curx,112
    mov   cury,0
    call  prbox
    ret
CSEG ends
     END
